## Submodule status

Version 8.x-2.x of this module contained processors (implementations of
CustomElementProcessorInterface) which all applied to a certain paragraph type.

Version 3.x ships without any of these processors. it should be possible to
replace those with Custom Elements Displays that are included as configuration.

Given the very low install base of this module, there's no
seamless/supported upgrade path.

## Status of processors

The video processor from version 8.x-2.x was still dependent on the
[Video Embed field](https://www.drupal.org/project/video_embed_field) module,
which has not been used by Thunder's video media type since version
8.x-3.x-beta1 / 3.3.0-beta1 (targeted at Drupal 9). The converted configuration
still has this dependency (and the custom_elements module contains a
"video_embed" CE field formatter that applies to 'video_embed_field' fields.

(Other processers' status wasn't checked in detail, but this one stands out, as
the module still has a dependency on video_embed_field.)

## Upgrading this module from version 8.x-2.x

The upgrade is NOT designed to be seamless: output may change when you start
using configuration. If you want to investigate all details beforehand: check
the intended new output in tests/src/Kernel/ThunderParagraphRenderMarkupTest.php
vs. the old output in tests/src/Functional/CustomElementsRenderMarkupTest.php
in version 8.x-2.x.

It is expected that a slight change in the output is not a problem, because
this is easily changed accordingly, in the Vue frontend components - and
things will work again.

### Reinstating old processors (WARNING: extended processors break with 3.x)

If your own codebase is extending the processors that were shipped with version
8.x-2.x, you need the old processors (or need to update your code before
upgrading to version 3.x), otherwise your code will break.

This module made a decision to stop supporting those processors immediately
with the 3.x release. But a module to install alongside version 3.x,
containing the old processors plus a README document outlining update steps, is
available at https://www.drupal.org/i/3443366.

### Upgrading without the old processors

* Check if you're still using video_embed_field. (Likely yes, because this
  module still has that dependency. If not: remove
  config/install/custom_elements.entity_ce_display.media.video.default.yml.)

* Import the configuration:
  `drush config:import --partial --source=MODULE_ROOT/modules/custom_elements_thunder/config-install`

* See what the new output looks like.

If you want to experiment / roll some things back: enable custom_elements_ui and
* Configure your own formatter at e.g. admin/structure/media/manage/video/ce-display
  or admin/structure/paragraphs_type/video/ce-display.
* Enable custom display settings for non-default view modes, if needed.
* If you want to switch back to using a custom Processor that was used in
  version 8.x-2.x, instead of this display: turn on the "Automatic processing"
  option.
